apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ postfix_name }}
  name: {{ postfix_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ postfix_replicas }}
  selector:
    matchLabels:
      name: {{ postfix_name }}
  serviceName: {{ postfix_name }}
  template:
    metadata:
      labels:
        name: {{ postfix_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ postfix_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ postfix_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - args:
        - /start-postfix.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DKIM_HOST
          value: "{{ '127.0.0.1' if (do_dkim) else '' }}"
        - name: DKIM_PORT
          value: "12345"
        - name: DONT_GENERATE_MAPS
          value: yay
        - name: LMTP_HOST
          value: {{ lmtp_address | urlsplit('hostname') }}
        - name: LMTP_PORT
          value: "{{ lmtp_address | urlsplit('port') }}"
        - name: MAXSIZE
          value: "{{ postfix_max_message_size }}"
        - name: MYDOMAIN
          value: {{ root_domain }}
        - name: MYHOSTNAME
          value: smtp.{{ root_domain }}
        - name: MYNETWORKS
          value: {{ postfix_my_networks | join(' ') }} 127.0.0.1/32
        - name: PBLS
          value: {{ postfix_pbls | join(' ') }}
        - name: SPAMD_HOST
{% if do_rspamd %}
          value: {{ rspamd_milter_address | urlsplit('hostname') }}
        - name: SPAMD_PORT
          value: "{{ rspamd_milter_address | urlsplit('port') }}"
{% elif do_orangeassassin %}
          value: {{ orange_address | urlsplit('hostname') }}
        - name: SPAMD_PORT
          value: "{{ orange_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: SPAMD_PORT
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='postfix'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - /usr/local/bin/check_smtp.sh
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 6
        name: postfix
        ports:
        - containerPort: 25
        - containerPort: 465
        - containerPort: 587
        resources:
          limits:
            cpu: {{ postfix_cpu_limit }}
            memory: {{ postfix_memory_limit }}
          requests:
            cpu: {{ postfix_cpu_request }}
            memory: {{ postfix_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/postfix
          name: data
          subPath: config
        - mountPath: /etc/saslauthd.conf
          name: authconfig
          subPath: saslauthd.conf
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/saslauthd
          name: tmp
          subPath: saslauthd
        - mountPath: /var/spool/postfix
          name: data
          subPath: spool
        - mountPath: /var/spool/postfix/var/run/saslauthd
          name: tmp
          subPath: saslauthd
      - args:
        - /start-syslog.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='postfix'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -e /run/rsyslog/dev/log || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: syslog
        resources:
          limits:
            cpu: {{ rsyslog_cpu_limit }}
            memory: {{ rsyslog_memory_limit }}
          requests:
            cpu: {{ rsyslog_cpu_request }}
            memory: {{ rsyslog_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /var/log/postfix
          name: tmp
          subPath: maillogs
      - args:
        - /start-saslauthd.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='postfix'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -e /run/saslauthd/mux || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: saslauthd
        resources:
          limits:
            cpu: {{ saslauthd_cpu_limit }}
            memory: {{ saslauthd_memory_limit }}
          requests:
            cpu: {{ saslauthd_cpu_request }}
            memory: {{ saslauthd_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/saslauthd.conf.d/saslauthd.conf
          name: authconfig
          subPath: saslauthd.conf
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
        - mountPath: /run/saslauthd
          name: tmp
          subPath: saslauthd
{% if do_dkim %}
      - args:
        - /start-opendkim.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DKIM_HOST
          value: 127.0.0.1
        - name: DKIM_PORT
          value: "12345"
        - name: MYNETWORKS
          value: {{ postfix_my_networks | join(' ') }} 127.0.0.1/32
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='postfix'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -s /run/opendkim/opendkim.pid || exit 1
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: opendkim
        resources:
          limits:
            cpu: {{ opendkim_cpu_limit }}
            memory: {{ opendkim_memory_limit }}
          requests:
            cpu: {{ opendkim_cpu_request }}
            memory: {{ opendkim_memory_request }}
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /etc/dkim.d/keys/{{ root_domain }}
          name: dkimkeys
        - mountPath: /run/rsyslog
          name: tmp
          subPath: rsyslog
{% endif %}
      - args:
        - /run-job.sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LMTP_HOST
          value: {{ lmtp_address | urlsplit('hostname') }}
        - name: LMTP_PORT
          value: "{{ lmtp_address | urlsplit('port') }}"
        - name: MAILDROP_PORT
{% if maildrop_smtp_address | default(False) %}
          value: "{{ maildrop_smtp_address | urlsplit('port') }}"
        - name: MAILDROP_RELAY
          value: {{ maildrop_smtp_address | urlsplit('hostname') }}
        - name: MAILDROP_SUBDOMAIN
          value: maildrop
{% else %}
          value: ""
        - name: MAILDROP_RELAY
          value: ""
        - name: MAILDROP_SUBDOMAIN
          value: ""
{% endif %}
        - name: MAILHOG_PORT
{% if mailhog_smtp_address | default(False) %}
          value: "{{ mailhog_smtp_address | urlsplit('port') }}"
        - name: MAILHOG_RELAY
          value: {{ mailhog_smtp_address | urlsplit('hostname') }}
        - name: MAILHOG_SUBDOMAIN
          value: mailhog
{% else %}
          value: ""
        - name: MAILHOG_RELAY
          value: ""
        - name: MAILHOG_SUBDOMAIN
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=postfix,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: postfix-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ postfix_ldap_user_objectclass }}
{% endif %}
        - name: SMTP_RELAY
          value: "{{ smtp_relay | default('') }}"
        - name: SMTP_RELAY_PORT
          value: "{{ smtp_port | default(25) }}"
        - name: SMTP_RELAY_PROTO
          value: {{ smtp_proto | default('smtp') }}
        - name: SYMPA_PORT
{% if sympa_smtps_address | default(False) %}
          value: "{{ sympa_smtps_address | urlsplit('port') }}"
        - name: SYMPA_PROTO
          value: smtps
        - name: SYMPA_RELAY
          value: {{ sympa_smtps_address | urlsplit('hostname') }}
        - name: SYMPA_SUBDOMAIN
          value: lists
{% elif sympa_smtp_address | default(False) %}
          value: "{{ sympa_smtp_address | urlsplit('port') }}"
        - name: SYMPA_PROTO
          value: smtp
        - name: SYMPA_RELAY
          value: {{ sympa_smtp_address | urlsplit('hostname') }}
        - name: SYMPA_SUBDOMAIN
          value: lists
{% else %}
          value: ""
        - name: SYMPA_PROTO
          value: ""
        - name: SYMPA_RELAY
          value: ""
        - name: SYMPA_SUBDOMAIN
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='postfix'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -s /etc/postfix/transport || exit 1
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 120
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 2
        name: job
        resources:
          limits:
            cpu: {{ postfix_job_cpu_limit }}
            memory: {{ postfix_job_memory_limit }}
          requests:
            cpu: {{ postfix_job_cpu_request }}
            memory: {{ postfix_job_memory_request }}
        securityContext:
          privileged: true
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          exec:
            command:
            - sh
            - -c
            - |
                test -s /etc/postfix/transport || exit 1
          failureThreshold: 120
          initialDelaySeconds: 30
          periodSeconds: 20
{% endif %}
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/postfix
          name: data
          subPath: config
{% if do_exporters %}
      - args:
        - --postfix.logfile_path=/var/log/postfix/maillog
        - --postfix.showq_path=/var/spool/postfix/public/showq
        - --web.listen-address=:9113
        image: {{ (opsimages | json_query("[?name=='postfixexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          privileged: true
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
{% endif %}
        volumeMounts:
        - mountPath: /etc/postfix
          name: data
          subPath: config
        - mountPath: /var/log/postfix
          name: tmp
          subPath: maillogs
        - mountPath: /var/spool/postfix
          name: data
          subPath: spool
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ postfix_name }}
{% else %}
      serviceAccountName: default
{% endif %}
      terminationGracePeriodSeconds: {{ postfix_termination_timeout | default(60) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ postfix_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: authconfig
        secret:
          secretName: {{ postfix_name }}
{% if do_dkim %}
      - name: dkimkeys
        secret:
          defaultMode: 420
          secretName: {{ postfix_name }}-dkim
{% endif %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor == 'kubernetes' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
          - secret:
              items:
              - key: ca.crt
                path: cyrus-ca.crt
{% if cyrus_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
          - secret:
              items:
              - key: tls.crt
                path: tls.crt
              name: {{ postfix_name }}-tls
          - secret:
              items:
              - key: tls.key
                path: tls.key
              name: {{ postfix_name }}-tls
      - emptyDir: {}
        name: tmp
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: {{ postfix_data_capacity }}
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
